/*
 *
*/


//Uart test
#include <HDL51001_ccf.h>
#include <uart.h>

#include <tim.h>

#define PSCPERIOD 1 //prediv timer0


 typedef unsigned int        UINT, *PUINT;
 typedef unsigned int        UINT32, *PUINT32;

 
 void StartTimer(UINT32 *TimeValue);
 //void StartTimer(int *TimeValue);

//==============================================================================
//==============================================================================
//==============================================================================


/* PopCnt */
static UINT PopCnt32(UINT v)
{
	v = v - ((v >> 1) & 0x55555555);                    // reuse input as temporary
	v = (v & 0x33333333) + ((v >> 2) & 0x33333333);     // temp
	v = (v + (v >> 4)) & 0x0F0F0F0F;
	return (v * 0x01010101) >> 24; // count
}



void pause(unsigned int a)
{
  unsigned int i;
  for(i=a;i>0;i--);
}

int main(int argc, char *argv[])
{

 int time_value;
 int i;

 UART_InitTypeDef UART_InitStructure;
	    
	  UART_InitStructure.BaudRate = 38400; //set baudrate
    UART_InitStructure.TypeParity = 0x00000000; //parity control type
    UART_InitStructure.Parity = 0x00000000; //enable parity control
    UART_InitStructure.FlowControl = 0x00000000; //enable cts/rts
    UART_InitStructure.Mode = 0x00000003; //rx enable - 1 bit, tx enable - 2 bit (rx + tx en)
    
		GPIOB->BPS = 0x00000300;		 //alternative port function for uart0
		uart_init(UART0, &UART_InitStructure);

  UART_SEND_BYTE(0xAB, UART0);
	while(UART_FIFO_TX_EMPTY(UART0) == 0); 
	uart_send_int(time_value, UART0);
	while(UART_FIFO_TX_EMPTY(UART0) == 0);
  UART_SEND_BYTE(0xAE, UART0);
	while(UART_FIFO_TX_EMPTY(UART0) == 0); 

    
  i = 1;


 while (i<2)
 {

  StartTimer((UINT32*)&time_value);
  
  UART_SEND_BYTE(0xBB, UART0);
	while(UART_FIFO_TX_EMPTY(UART0) == 0); 
	uart_send_int(time_value, UART0);
	while(UART_FIFO_TX_EMPTY(UART0) == 0);
  UART_SEND_BYTE(0xBE, UART0);
	while(UART_FIFO_TX_EMPTY(UART0) == 0); 
 
  i++;
 }

 return 0; 
		
}
